/****************************************************************************************************************/
/* Decode each function occurrence and the respective relationships
/* Mike Renner                                                                                                  */
/****************************************************************************************************************/

var oOutput = Context.createOutputObject();     // Output object
//Context.createOutputObject(OutputFormat, FileName)
var nLocale = Context.getSelectedLanguage();    // Selected database language

oOutput.BeginTable(100, Constants.C_BLACK, Constants.C_TRANSPARENT, Constants.FMT_LEFT, 0);          
oOutput.TableRow();    
oOutput.TableCell("Function name", 15, "Arial", 10, Constants.C_BLACK, Constants.C_LIGHT_YELLOW, 0, Constants.FMT_BOLD | Constants.FMT_LEFT | Constants.FMT_VTOP, 0);
oOutput.TableCell("Connection Type", 10, "Arial", 10, Constants.C_BLACK, Constants.C_LIGHT_YELLOW, 0, Constants.FMT_BOLD | Constants.FMT_LEFT | Constants.FMT_VTOP, 0);
oOutput.TableCell("Connection Name", 10, "Arial", 10, Constants.C_BLACK, Constants.C_LIGHT_YELLOW, 0, Constants.FMT_BOLD | Constants.FMT_LEFT | Constants.FMT_VTOP, 0);
oOutput.TableRow();

var aModels = ArisData.getSelectedModels();     // Array of selected models
for (var i = 0; i < aModels.length; i++) {            
    var oModel = aModels[i];                    // Current model
    var sModelName = oModel.Name(nLocale);      // Name of current model
  
    // Get all functions in model
    var oFuncOccs = oModel.ObjOccListFilter(Constants.OT_FUNC);
    //var oFuncOccs = oModel.ObjOccListFilter();  // no filter
    oFuncOccs = ArisData.sort(oFuncOccs, Constants.SORT_X, nLocale);
    // Loop through function objects
    for (var j = 0; j < oFuncOccs.length; j++) {
        oOutput.TableCell(oFuncOccs[j].ObjDef().Name(nLocale), 15, "Arial", 10, Constants.C_BLACK, Constants.C_TRANSPARENT, 0, Constants.FMT_LEFT | Constants.FMT_VTOP, 0);   //name of function      
        oOutput.TableCell("OBJECT END", 10, "Arial", 10, Constants.C_BLACK, Constants.C_LIGHT_YELLOW, 0, Constants.FMT_BOLD | Constants.FMT_LEFT | Constants.FMT_VTOP, 0);
        oOutput.TableRow();
        if(0)  // Another way to get relationships
        {
        // list relationships per occurrence
        var aCxnOccFunc = oFuncOccs[j].CxnOccList();
        for (var k = 0; k < aCxnOccFunc.length; k++) {
            //oOutput.TableCell(aCxnOccFunc[k].getDefinition(), 15, "Arial", 10, Constants.C_BLACK, Constants.C_TRANSPARENT, 0, Constants.FMT_LEFT | Constants.FMT_VTOP, 0);
            oOutput.TableCell(aCxnOccFunc[k].getDefinition().ActiveType(), 15, "Arial", 10, Constants.C_BLACK, Constants.C_TRANSPARENT, 0, Constants.FMT_LEFT | Constants.FMT_VTOP, 0);
            oOutput.TableRow();
        }
        oOutput.TableCell("END Relationship", 10, "Arial", 10, Constants.C_BLACK, Constants.C_LIGHT_YELLOW, 0, Constants.FMT_BOLD | Constants.FMT_LEFT | Constants.FMT_VTOP, 0);
        oOutput.TableRow();
        }


        
       // loop through connections        
        var aCxns = oFuncOccs[j].Cxns(Constants.EDGES_INOUT,Constants.EDGES_ALL)  //Returns the specified connections of the object occurrences.  
        for(var z=0;z<aCxns.length;z++){
             //var oSourceObjOcc = aCxns[z].SourceObjOcc();  //Report class CxnOcc - Method SourceObjOcc; Deprecated. use getSource() 
             var oSourceObjOcc = aCxns[z].getSource();
             oOutput.TableCell(z, 10, "Arial", 10, Constants.C_BLACK, Constants.C_TRANSPARENT, 0, Constants.FMT_LEFT | Constants.FMT_VTOP, 0);
             oOutput.TableCell("CONN Start", 15, "Arial", 10, Constants.C_BLACK, Constants.C_LIGHT_YELLOW, 0, Constants.FMT_BOLD | Constants.FMT_LEFT | Constants.FMT_VTOP, 0);
             oOutput.TableCell(aCxns[z].CxnDef().ActiveType(), 10, "Arial", 10, Constants.C_BLACK, Constants.C_TRANSPARENT, 0, Constants.FMT_LEFT | Constants.FMT_VTOP, 0);    //name of the connection     
             oOutput.TableCell(oSourceObjOcc.ObjDef().Name(nLocale), 10, "Arial", 10, Constants.C_BLACK, Constants.C_TRANSPARENT, 0, Constants.FMT_LEFT | Constants.FMT_VTOP, 0);       //name of soucre object for example person type  
             oOutput.TableRow();
        }
        oOutput.TableRow();    
    }
}
oOutput.EndTable("", 100, "Arial", 10, Constants.C_BLACK, Constants.C_TRANSPARENT, 0, Constants.FMT_LEFT | Constants.FMT_VTOP, 0);
oOutput.WriteReport();

